export const getFilterData = (filterConfig) => {
  const { data } = filterConfig;
  const { searchEntity } = filterConfig;
  const { selectedColumn } = filterConfig;
  const searchedData = [];
  const prop = 'id';
  let id = 0;
  data.forEach((obj) => {
    obj.id = id.toString();
    id += 1;
  });

  if (searchEntity === '') {
    return null;
  } else if (selectedColumn !== 'all') {
    return data.filter(
      x => x[selectedColumn].toLowerCase().includes(searchEntity.toLowerCase()),
    );
  }

  for (let i = 0; i < data.length; i += 1) {
    for (const key in data[i]) {
      if (data[i][key].toLowerCase().indexOf(searchEntity.toLowerCase()) !== -1) {
        searchedData.push(data[i]);
      }
    }
  }

  function removeDuplicates(result) {
    const obj = {};
    for (let i = 0, len = result.length; i < len; i += 1) {
      if (!obj[result[i][prop]]) obj[result[i][prop]] = result[i];
    }
    const newArr = [];
    for (const key in obj) newArr.push(obj[key]);
    return newArr;
  }
  const result = removeDuplicates(searchedData, prop);

  return result;
};

export const isEmpty = (data) => {
  for (const key in data) {
    if (Object.hasOwnProperty.call(data, key)) return false;
  }
  return true;
};

export const getNoOfPages = (data, recordsPerPage) => {
  const pageCount = [];
  for (let i = 1; i <= Math.ceil(data.length / recordsPerPage); i += 1) {
    pageCount.push(i);
  }
  return pageCount.length;
};

export const getData = (state) => {
  if (state.data != null) {
    if (state.recordsPerPage) {
      const indexOfLastRecord = state.currentPage * state.recordsPerPage;
      const indexOfFirstRecord = indexOfLastRecord - state.recordsPerPage;
      return state.data.slice(indexOfFirstRecord, indexOfLastRecord);
    } else {
      return state.data;
    }
  }
}
